function [S , Scale]= makeS(R,H,SS)
global NOISE
S = zeros(size(R,1),size(R,2),size(H,3));
for k=1:size(H,3)
    for r=1:size(R,1)        
        for L=1:size(R,2)
            if (R(r,L)~=0)
                G = R(r,[[1:L-1],[L+1:size(R,2)]]) * squeeze(H([[1:L-1],[L+1:size(R,2)]],L,k));
                S(r,L,k) = log(1 + H(L,L,k)*R(r,L)/(NOISE+G));
            else
                S(r,L,k)=0;
            end
        end
    end
end
if (nargin==2)
    Scale = 1/max(max(S));
    S=Scale*S;
else
    Scale=SS;
    S=Scale*S;
end
            
    
