% LinkPairs
Alpha = 1;  % Threshold

% Only one link is on 
OneLinkAssign = eye(size(Links,1));
OneLinkAssignBW = MakeS(OneLinkAssign, H,VScale);

% Acceptable links for link i in the two links case
for i=1:size(Links,1)
    AL{i} = [];
end

for i=1:size(Links,1)-1
    for j=i+1:size(Links,1)
        TwoLinksAssign = OneLinkAssign(i,:) | OneLinkAssign(j,:);
        TwoLinksAssignBW = MakeS(TwoLinksAssign, H,VScal);
        if ((Alpha - TwoLinksAssignBW(i)/ OneLinkAssignBW(i,i)) * OneLinkAssignBW(j,j) < TwoLinksAssignBW(j))
            AL{i} = [AL{i}; j];
            AL{j} = [AL{j}; i];
        end        
    end   
end

% Construct a new assignment to approximate max{ru}
NewAssign=[];
NewAL=[1:size(Links,1)];
while (isempty(NewAL) == 0)
    I = NewAL(find(Mu(NewAL) == max(Mu(NewAL))));
    NewAssign = [NewAssign; I(1)];
    NewAL = intersect(NewAL, AL{I(1)});
end

NewAssign = sort(NewAssign)

