global NOISE
warning off MATLAB:singularMatrix
warning off MATLAB:nearlySingularMatrix
Hyperplanes=[];
DistanceFromOrigin=[];
NOISE =1e-9;

PickRandTop
Thresh=55;

%BasePath = 'G:\UDelModels\ReleasedCitiesV1V1\RealisiticCities\Chicago2kmx2km\Experiments\JustOutdoorBasestations\Trial1\';
%BasePath = 'G:\UDelModels\ReleasedCitiesV1V1\RealisiticCities\Chicago9x9Blk\Experiments\JustOutdoorBasestations\Trial1\outputdata';
%BasePath = 'D:\pwang\subbands';
BasePath = '.\';

%eval(sprintf('load %s/default.propagation.0.mat',BasePath));
eval(sprintf('load %s/default.propagation.0.SB.mat',BasePath));

PL=PL_FULL;

while (1)
    Hit = zeros(size(PL,1),1);
    Hit(BS) = 1;
    clear P
    P{BS}=BS;

    while (1)
        I = find(Hit==1);
        if (isempty(I)==1)
            break;
        end
        for ii=1:length(I)
            Hit(I)=2;
            J = find(PL(I(ii),:)<Thresh & (Hit'==0 | Hit'==1));
            for j = 1:length(J)
%                 if (J(j)==46)
%                     46
%                 end
                if (Hit(J(j))==1)
                    % check which rt is better
                    mx = 0;
                    for m=1:length(P{J(j)})-1
                        mx = max(mx,PL(P{J(j)}(m),P{J(j)}(m+1)));
                    end
                    mx2 = PL(I(ii),J(j));
                    for m=1:length(P{I(ii)})-1
                        mx2 = max(mx2,PL(P{I(ii)}(m),P{I(ii)}(m+1)));
                    end
                    if (mx2<mx)
                        P{J(j)} = [P{I(ii)},J(j)];
                    end
                else
                    P{J(j)} = [P{I(ii)},J(j)];
                    Hit(J(j))=1;
                end
            end
        end
    end

    clear Routes
    for n=1:length(Dest)
        Routes{n} = P{Dest(n)};
    end


    Links=[];  % a list of all links
    clear Paths % each flow uses a set of links. Path{i} is the set of links used by flow i
    for i=1:length(Routes)
        Paths{i}=[];
        for j=1:length(Routes{i})-1
            if (isempty(Links)==0)
                I = find(Links(:,1)==Routes{i}(j) & Links(:,2)==Routes{i}(j+1));
            else
                I=[];
            end
            if (isempty(I)==1)
                Links=[Links;Routes{i}(j:j+1)];
                Paths{i}=[Paths{i};size(Links,1)];
            else
                Paths{i}=[Paths{i};I];
            end            
        end
    end
    
    %if (0 && (size(Links,1) < 14 || size(Links,1)>16))
    %if (size(Links,1)>NumLinks(rem(nnn, length(NumLinks))+1))  %pwang
    if (size(Links,1)>NumLinks(rem(nnn, length(NumLinks))))  %pwang
    Dest(ceil(rand(1)*length(Dest)))=[];
    else
        break;
    end
end

size(Links)

clear FlowUsage % each link is used by a set of flows FlowUsage{i} is the list of flows that used link i
for i=1:size(Links,1)
    FlowUsage{i}=[];
    for j=1:length(Paths)
        I = find(Paths{j}==i);
        if (isempty(I)==0)
            FlowUsage{i} = [FlowUsage{i};j];
        end
    end
end
    

H = zeros(size(Links,1)); % channel gains H(i,j) is the channel gain from the transmitter of link i to the receiver of link j. So H(i,i) is the channel gain acros link i
for i=1:size(Links,1)
    for j=1:size(Links,1)
        if (Links(i,1)~=Links(j,2))
            H(i,j) = PL(Links(i,1),Links(j,2)); 
            H(i,j) = 10^(-H(i,j)/10);           
        else
            H(i,j)=1e9;
        end
    end
end

HH = H;
I=find(HH(:)>1e6);
HH(I)=-1e-5;



S = eye(size(Links,1)); % each link on, and only that link on. If these are not included, then werid things may occur. 
[V, VScale] = MakeS(S,H);
MakeLinkPairs;
% make blocks such that all ok pairs are included
Included = zeros(size(Links,1),1);
while (min(Included)==0)
    I = min(find(Included==0));
    Included(I)=1;
    tS = zeros(1,size(Links,1));
    tS(I)=1;
    al = intersect(AL{I},find(Included==0));
    while (isempty(al)==0)
        Included(al(1))=1;
        tS(al(1))=1;
        al = intersect(AL{al(1)},al);  % al only includes non-included links
    end
    S=[S;tS];
end

sz= size(S,1);
while (size(S,1)<sz+0) % add 0 random assigments
    p = randperm(size(Links,1));
    r=zeros(1,size(Links,1));
    for j=1:size(Links,1)
        I = find( H(p(j),find(r==1))>100 | H(find(r==1),p(j))'>100);
        if (isempty(I)==1)
            % neighbor links are not on
            if (rand(1)<.5)
                r(p(j))=1;
            end
        end
    end
    fd=0;
    for j=1:size(S,1)
        if (norm(S(j,:)-r)==0)
            fd=1;
            break;
        end
    end
    if (fd==0)
        S=[S;r];
    end
end
       
if (0)
    % all possible assignments
    S = zeros(2^size(Links,1)-1,size(Links,1));    
    for i=2:2^size(Links,1)
        ii = dec2bin(i-1);
        for j=1:length(ii)
            S(i-1,j)=str2num(ii(length(ii)-j+1));
        end
    end
end


V = MakeS(S,H,VScale);
    
Mu = ones(size(V,2),1);
        
    
    

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


if (1)

% Open file
%fid = fopen([BasePath,'\default.mobility'],'rt');     % 'rt' means "read text"
fid = fopen([BasePath,'\default.mobility.SB'],'rt');     % 'rt' means "read text"
if (fid < 0)
    error('could not open file "default.mobility"');
end;

% Read the node information of Chicago
NodeData = fscanf(fid,'%d %d (%g,%g,%g) %g %g %*s # %d %d %d\n',[10,size(PL_FULL,1)]);
% close the file
fclose(fid);

figure(1)
clf
hold on
plot(NodeData(3,BS),NodeData(4,BS),'o','markersize',12);
for n=1:length(Routes)
    for i=1:length(Routes{n})-1
        plot([NodeData(3,Routes{n}(i));NodeData(3,Routes{n}(i+1))],[NodeData(4,Routes{n}(i));NodeData(4,Routes{n}(i+1))],'-x')
    end
end

end







    
    