G=100000;
if (exist('Mu','var') == 0)
    Mu = ones(size(V,2),1);
else
    if (length(Mu)~=size(V,2))
        Mu = ones(size(V,2),1);
    end
end

RCount=0;
Gt=0;
cc=0;
OldMu = Mu;
B=eye(length(Mu));
beta = 1/2;
SchSuc=0;


while (norm(G)/norm(Mu) > 1e-8)

    %[G, VL,x,VM,F] = MakeSubgradient(Mu,V,Paths,FlowUsage);
    %    CarefulSubGrad
    Careful2
    if (SchSuc==1 || SchSuc==-1)
        disp('***********************************************************');
        disp('subgrad decided that the current value of mu could not be improved');
        break
    end
    if (min(VL*G)<0 && b==0)
        disp('descent direction is not a descent direction!');
        NDD=NDD+1;
        if (NDD>3)
            disp('failed to find a descent direction 3 times, press any key to continue');
            pause
        end
    else
        NDD=0;
    end
    if (max(Gt)~=0)
        Gs = B' * G;
        r =Gs - Gt;
        r=r/norm(r);
        R = (beta-1)*r*r' + eye(length(Mu));
        B = B * R;
        Gt = R*Gs;
    else
        Gt = G;
    end
    Gt(find(Gt<0 & Mu<=0))=0;

    if ((min(VL*Gt)<0) || RCount >= 10*length(Mu))
        % not a direction of descent or time to reset
        disp('resetting')
        Gt = G;
        B=eye(length(Mu));
        RCount = 0;
        MakeRealSch
        if (SchSuc==1)
            disp('***********************************************************');
            disp('when reseting found that current value is good enough to stop');
            break
        end
    end
    RCount = RCount + 1;
    Mu = SubGradLineSearch(Gt*ScaleG,Mu,V,Paths, FlowUsage);
    Mu(find(Mu<0))=0;
    if (max(Mu)>1e12)
        max(Mu)
        pause
    end
    cc=cc+1;
    [cc, RCount, norm(Gt),norm(Mu-OldMu),min( ((VM'*x)'-F')./F')]

    OldMu=Mu;
end

if (norm(G)/norm(Mu) <= 1e-8)
    disp('***********************************************************');
    disp('grad is very small, so stopping');
end

MakeRealSch