

Q = VL*VL';
Name = 'QP Example';
c = [ ];
A = ones(1,size(Q,1));
A = [A;10000*Q];
b_L = [1]'; % Lower bounds on the linear constraints

b_U = [1]'; % Upper bounds on the linear constraints
b_U = [b_U;inf+zeros(size(Q,1),1)];
x_L = zeros(size(Q,1),1); % Lower bounds on the variables
x_U = x_L+inf; % Upper bounds on the variables
x_0 = [];%[1;zeros(size(Q,1)-1,1)]; % Starting point


cnt=0;
epL=0;
epH=1;

cnt=0;
while (cnt<1000)
    b_L = [1;epH+zeros(size(Q,1),1)];
    Prob = qpAssign(Q, c, A, b_L, b_U, x_L, x_U, x_0, Name,...
        [], [], [],[],[]);
    Result = tomRun('qp-minos', Prob, 0);
    G = VL'*Result.x_k;
    if (Result.Inform == 0)
        if (min(VL*G)<0)
            epH=epH*2;
        else
            % found a sol
            break;
        end
    else
        break;
    end
end
if (cnt==1000)
    disp('not sure what to do hg')
    pause
end

if (Result.Inform~=0 || min(VL*G)<0)
    % otherwise we are done

    % find the point where it goes from VL*G<0 to infeasiable - if it exists
    cnt=0;
    while (cnt<1000)
        cnt=cnt+1;
        b_L = [1;(epL+epH)/2+zeros(size(Q,1),1)];       Prob = qpAssign(Q, c, A, b_L, b_U, x_L, x_U, x_0, Name,[], [], [],[],[]); Result = tomRun('qp-minos', Prob, 0); Q*Result.x_k
        G = VL'*Result.x_k;
        if (Result.Inform==0 && min(VL*G)>0)
            epH = (epL+epH)/2;
            break
        else
            if (Result.Inform==0)
                epL =(epL+epH)/2;
            else
                epH =(epL+epH)/2;
            end
        end
        if (epH-epL < 1e-16)            
            break;
        end
    end
end

if (Result.Inform~=0 || min(VL*G)<0)
    disp('could not find a good direction')
    pause
else
    disp('found a good dir')
end
    
    