function u = GradUtil(p)
global HI
global NOISE
global MuI
global VScale
u = zeros(length(p),1);
U = zeros(length(p),1);
W = zeros(length(p),1);
if (size(p,1)>size(p,2))
    p = p';
end
for j = 1 : length(p)
    U(j) = MuI(j)*HI(j,j) / (p*HI(:,j) + NOISE);
    if (p(j)~=0)    
        uu=0;
        for i = 1 : length(p)
            if (i~=j)
                uu = uu + p(i)*HI(i,j);
            end
        end
        W(j) = U(j) * p(j) / (uu + NOISE);
        %W(j) = U(j) * p(j) / (p*HI(:,j) - p(j)*HI(j,j) + NOISE);
    end
end
%u = -VScale*(U - HI*W + diag(HI).*W);
for i=1:length(p)
    u(i) = U(i);
    for j = 1:length(p)
        if (i~=j)
            u(i) = u(i) - HI(i,j)*W(j);
        end
    end
end
u = -VScale*u;